<?php

namespace Ups\upsshipStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AdditionalInfoType upsshipStruct
 * @package Ups
 * @subpackage Structs
 */
class UpsAdditionalInfoType extends AbstractStructBase
{
    /**
     * The Type
     * @var string
     */
    public $Type;
    /**
     * The Value
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \Ups\upsshipStruct\UpsAdditionalCodeDescType[]
     */
    public $Value;
    /**
     * Constructor method for AdditionalInfoType
     * @uses UpsAdditionalInfoType::setType()
     * @uses UpsAdditionalInfoType::setValue()
     * @param string $type
     * @param \Ups\upsshipStruct\UpsAdditionalCodeDescType[] $value
     */
    public function __construct($type = null, array $value = array())
    {
        $this
            ->setType($type)
            ->setValue($value);
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \Ups\upsshipStruct\UpsAdditionalInfoType
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get Value value
     * @return \Ups\upsshipStruct\UpsAdditionalCodeDescType[]|null
     */
    public function getValue()
    {
        return $this->Value;
    }
    /**
     * This method is responsible for validating the values passed to the setValue method
     * This method is willingly generated in order to preserve the one-line inline validation within the setValue method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateValueForArrayConstraintsFromSetValue(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $additionalInfoTypeValueItem) {
            // validation for constraint: itemType
            if (!$additionalInfoTypeValueItem instanceof \Ups\upsshipStruct\UpsAdditionalCodeDescType) {
                $invalidValues[] = is_object($additionalInfoTypeValueItem) ? get_class($additionalInfoTypeValueItem) : sprintf('%s(%s)', gettype($additionalInfoTypeValueItem), var_export($additionalInfoTypeValueItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Value property can only contain items of type \Ups\upsshipStruct\UpsAdditionalCodeDescType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Value value
     * @throws \InvalidArgumentException
     * @param \Ups\upsshipStruct\UpsAdditionalCodeDescType[] $value
     * @return \Ups\upsshipStruct\UpsAdditionalInfoType
     */
    public function setValue(array $value = array())
    {
        // validation for constraint: array
        if ('' !== ($valueArrayErrorMessage = self::validateValueForArrayConstraintsFromSetValue($value))) {
            throw new \InvalidArgumentException($valueArrayErrorMessage, __LINE__);
        }
        $this->Value = $value;
        return $this;
    }
    /**
     * Add item to Value value
     * @throws \InvalidArgumentException
     * @param \Ups\upsshipStruct\UpsAdditionalCodeDescType $item
     * @return \Ups\upsshipStruct\UpsAdditionalInfoType
     */
    public function addToValue(\Ups\upsshipStruct\UpsAdditionalCodeDescType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Ups\upsshipStruct\UpsAdditionalCodeDescType) {
            throw new \InvalidArgumentException(sprintf('The Value property can only contain items of type \Ups\upsshipStruct\UpsAdditionalCodeDescType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Value[] = $item;
        return $this;
    }
}
