<?php

namespace Ups\upsshipStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactType upsshipStruct
 * @package Ups
 * @subpackage Structs
 */
class UpsContactType extends AbstractStructBase
{
    /**
     * The ForwardAgent
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups\upsshipStruct\UpsForwardAgentType
     */
    public $ForwardAgent;
    /**
     * The UltimateConsignee
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups\upsshipStruct\UpsUltimateConsigneeType
     */
    public $UltimateConsignee;
    /**
     * The IntermediateConsignee
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups\upsshipStruct\UpsIntermediateConsigneeType
     */
    public $IntermediateConsignee;
    /**
     * The Producer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups\upsshipStruct\UpsProducerType
     */
    public $Producer;
    /**
     * The SoldTo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups\upsshipStruct\UpsSoldToType
     */
    public $SoldTo;
    /**
     * Constructor method for ContactType
     * @uses UpsContactType::setForwardAgent()
     * @uses UpsContactType::setUltimateConsignee()
     * @uses UpsContactType::setIntermediateConsignee()
     * @uses UpsContactType::setProducer()
     * @uses UpsContactType::setSoldTo()
     * @param \Ups\upsshipStruct\UpsForwardAgentType $forwardAgent
     * @param \Ups\upsshipStruct\UpsUltimateConsigneeType $ultimateConsignee
     * @param \Ups\upsshipStruct\UpsIntermediateConsigneeType $intermediateConsignee
     * @param \Ups\upsshipStruct\UpsProducerType $producer
     * @param \Ups\upsshipStruct\UpsSoldToType $soldTo
     */
    public function __construct(\Ups\upsshipStruct\UpsForwardAgentType $forwardAgent = null, \Ups\upsshipStruct\UpsUltimateConsigneeType $ultimateConsignee = null, \Ups\upsshipStruct\UpsIntermediateConsigneeType $intermediateConsignee = null, \Ups\upsshipStruct\UpsProducerType $producer = null, \Ups\upsshipStruct\UpsSoldToType $soldTo = null)
    {
        $this
            ->setForwardAgent($forwardAgent)
            ->setUltimateConsignee($ultimateConsignee)
            ->setIntermediateConsignee($intermediateConsignee)
            ->setProducer($producer)
            ->setSoldTo($soldTo);
    }
    /**
     * Get ForwardAgent value
     * @return \Ups\upsshipStruct\UpsForwardAgentType|null
     */
    public function getForwardAgent()
    {
        return $this->ForwardAgent;
    }
    /**
     * Set ForwardAgent value
     * @param \Ups\upsshipStruct\UpsForwardAgentType $forwardAgent
     * @return \Ups\upsshipStruct\UpsContactType
     */
    public function setForwardAgent(\Ups\upsshipStruct\UpsForwardAgentType $forwardAgent = null)
    {
        $this->ForwardAgent = $forwardAgent;
        return $this;
    }
    /**
     * Get UltimateConsignee value
     * @return \Ups\upsshipStruct\UpsUltimateConsigneeType|null
     */
    public function getUltimateConsignee()
    {
        return $this->UltimateConsignee;
    }
    /**
     * Set UltimateConsignee value
     * @param \Ups\upsshipStruct\UpsUltimateConsigneeType $ultimateConsignee
     * @return \Ups\upsshipStruct\UpsContactType
     */
    public function setUltimateConsignee(\Ups\upsshipStruct\UpsUltimateConsigneeType $ultimateConsignee = null)
    {
        $this->UltimateConsignee = $ultimateConsignee;
        return $this;
    }
    /**
     * Get IntermediateConsignee value
     * @return \Ups\upsshipStruct\UpsIntermediateConsigneeType|null
     */
    public function getIntermediateConsignee()
    {
        return $this->IntermediateConsignee;
    }
    /**
     * Set IntermediateConsignee value
     * @param \Ups\upsshipStruct\UpsIntermediateConsigneeType $intermediateConsignee
     * @return \Ups\upsshipStruct\UpsContactType
     */
    public function setIntermediateConsignee(\Ups\upsshipStruct\UpsIntermediateConsigneeType $intermediateConsignee = null)
    {
        $this->IntermediateConsignee = $intermediateConsignee;
        return $this;
    }
    /**
     * Get Producer value
     * @return \Ups\upsshipStruct\UpsProducerType|null
     */
    public function getProducer()
    {
        return $this->Producer;
    }
    /**
     * Set Producer value
     * @param \Ups\upsshipStruct\UpsProducerType $producer
     * @return \Ups\upsshipStruct\UpsContactType
     */
    public function setProducer(\Ups\upsshipStruct\UpsProducerType $producer = null)
    {
        $this->Producer = $producer;
        return $this;
    }
    /**
     * Get SoldTo value
     * @return \Ups\upsshipStruct\UpsSoldToType|null
     */
    public function getSoldTo()
    {
        return $this->SoldTo;
    }
    /**
     * Set SoldTo value
     * @param \Ups\upsshipStruct\UpsSoldToType $soldTo
     * @return \Ups\upsshipStruct\UpsContactType
     */
    public function setSoldTo(\Ups\upsshipStruct\UpsSoldToType $soldTo = null)
    {
        $this->SoldTo = $soldTo;
        return $this;
    }
}
