<?php

namespace Ups\upsshipStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DGSignatoryInfoType upsshipStruct
 * @package Ups
 * @subpackage Structs
 */
class UpsDGSignatoryInfoType extends AbstractStructBase
{
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Title
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Title;
    /**
     * The Place
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Place;
    /**
     * The Date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Date;
    /**
     * The ShipperDeclaration
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ShipperDeclaration;
    /**
     * The UploadOnlyIndicator
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $UploadOnlyIndicator;
    /**
     * Constructor method for DGSignatoryInfoType
     * @uses UpsDGSignatoryInfoType::setName()
     * @uses UpsDGSignatoryInfoType::setTitle()
     * @uses UpsDGSignatoryInfoType::setPlace()
     * @uses UpsDGSignatoryInfoType::setDate()
     * @uses UpsDGSignatoryInfoType::setShipperDeclaration()
     * @uses UpsDGSignatoryInfoType::setUploadOnlyIndicator()
     * @param string $name
     * @param string $title
     * @param string $place
     * @param string $date
     * @param string $shipperDeclaration
     * @param string $uploadOnlyIndicator
     */
    public function __construct($name = null, $title = null, $place = null, $date = null, $shipperDeclaration = null, $uploadOnlyIndicator = null)
    {
        $this
            ->setName($name)
            ->setTitle($title)
            ->setPlace($place)
            ->setDate($date)
            ->setShipperDeclaration($shipperDeclaration)
            ->setUploadOnlyIndicator($uploadOnlyIndicator);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \Ups\upsshipStruct\UpsDGSignatoryInfoType
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Title value
     * @return string|null
     */
    public function getTitle()
    {
        return $this->Title;
    }
    /**
     * Set Title value
     * @param string $title
     * @return \Ups\upsshipStruct\UpsDGSignatoryInfoType
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($title, true), gettype($title)), __LINE__);
        }
        $this->Title = $title;
        return $this;
    }
    /**
     * Get Place value
     * @return string|null
     */
    public function getPlace()
    {
        return $this->Place;
    }
    /**
     * Set Place value
     * @param string $place
     * @return \Ups\upsshipStruct\UpsDGSignatoryInfoType
     */
    public function setPlace($place = null)
    {
        // validation for constraint: string
        if (!is_null($place) && !is_string($place)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($place, true), gettype($place)), __LINE__);
        }
        $this->Place = $place;
        return $this;
    }
    /**
     * Get Date value
     * @return string|null
     */
    public function getDate()
    {
        return $this->Date;
    }
    /**
     * Set Date value
     * @param string $date
     * @return \Ups\upsshipStruct\UpsDGSignatoryInfoType
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date, true), gettype($date)), __LINE__);
        }
        $this->Date = $date;
        return $this;
    }
    /**
     * Get ShipperDeclaration value
     * @return string|null
     */
    public function getShipperDeclaration()
    {
        return $this->ShipperDeclaration;
    }
    /**
     * Set ShipperDeclaration value
     * @param string $shipperDeclaration
     * @return \Ups\upsshipStruct\UpsDGSignatoryInfoType
     */
    public function setShipperDeclaration($shipperDeclaration = null)
    {
        // validation for constraint: string
        if (!is_null($shipperDeclaration) && !is_string($shipperDeclaration)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($shipperDeclaration, true), gettype($shipperDeclaration)), __LINE__);
        }
        $this->ShipperDeclaration = $shipperDeclaration;
        return $this;
    }
    /**
     * Get UploadOnlyIndicator value
     * @return string|null
     */
    public function getUploadOnlyIndicator()
    {
        return $this->UploadOnlyIndicator;
    }
    /**
     * Set UploadOnlyIndicator value
     * @param string $uploadOnlyIndicator
     * @return \Ups\upsshipStruct\UpsDGSignatoryInfoType
     */
    public function setUploadOnlyIndicator($uploadOnlyIndicator = null)
    {
        // validation for constraint: string
        if (!is_null($uploadOnlyIndicator) && !is_string($uploadOnlyIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uploadOnlyIndicator, true), gettype($uploadOnlyIndicator)), __LINE__);
        }
        $this->UploadOnlyIndicator = $uploadOnlyIndicator;
        return $this;
    }
}
