<?php

namespace Ups\upsshipStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EEIFilingOptionType upsshipStruct
 * @package Ups
 * @subpackage Structs
 */
class UpsEEIFilingOptionType extends AbstractStructBase
{
    /**
     * The Code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Code;
    /**
     * The EMailAddress
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $EMailAddress;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * The UPSFiled
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups\upsshipStruct\UpsUPSFiledType
     */
    public $UPSFiled;
    /**
     * The ShipperFiled
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups\upsshipStruct\UpsShipperFiledType
     */
    public $ShipperFiled;
    /**
     * Constructor method for EEIFilingOptionType
     * @uses UpsEEIFilingOptionType::setCode()
     * @uses UpsEEIFilingOptionType::setEMailAddress()
     * @uses UpsEEIFilingOptionType::setDescription()
     * @uses UpsEEIFilingOptionType::setUPSFiled()
     * @uses UpsEEIFilingOptionType::setShipperFiled()
     * @param string $code
     * @param string $eMailAddress
     * @param string $description
     * @param \Ups\upsshipStruct\UpsUPSFiledType $uPSFiled
     * @param \Ups\upsshipStruct\UpsShipperFiledType $shipperFiled
     */
    public function __construct($code = null, $eMailAddress = null, $description = null, \Ups\upsshipStruct\UpsUPSFiledType $uPSFiled = null, \Ups\upsshipStruct\UpsShipperFiledType $shipperFiled = null)
    {
        $this
            ->setCode($code)
            ->setEMailAddress($eMailAddress)
            ->setDescription($description)
            ->setUPSFiled($uPSFiled)
            ->setShipperFiled($shipperFiled);
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \Ups\upsshipStruct\UpsEEIFilingOptionType
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get EMailAddress value
     * @return string|null
     */
    public function getEMailAddress()
    {
        return $this->EMailAddress;
    }
    /**
     * Set EMailAddress value
     * @param string $eMailAddress
     * @return \Ups\upsshipStruct\UpsEEIFilingOptionType
     */
    public function setEMailAddress($eMailAddress = null)
    {
        // validation for constraint: string
        if (!is_null($eMailAddress) && !is_string($eMailAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eMailAddress, true), gettype($eMailAddress)), __LINE__);
        }
        $this->EMailAddress = $eMailAddress;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \Ups\upsshipStruct\UpsEEIFilingOptionType
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Get UPSFiled value
     * @return \Ups\upsshipStruct\UpsUPSFiledType|null
     */
    public function getUPSFiled()
    {
        return $this->UPSFiled;
    }
    /**
     * Set UPSFiled value
     * @param \Ups\upsshipStruct\UpsUPSFiledType $uPSFiled
     * @return \Ups\upsshipStruct\UpsEEIFilingOptionType
     */
    public function setUPSFiled(\Ups\upsshipStruct\UpsUPSFiledType $uPSFiled = null)
    {
        $this->UPSFiled = $uPSFiled;
        return $this;
    }
    /**
     * Get ShipperFiled value
     * @return \Ups\upsshipStruct\UpsShipperFiledType|null
     */
    public function getShipperFiled()
    {
        return $this->ShipperFiled;
    }
    /**
     * Set ShipperFiled value
     * @param \Ups\upsshipStruct\UpsShipperFiledType $shipperFiled
     * @return \Ups\upsshipStruct\UpsEEIFilingOptionType
     */
    public function setShipperFiled(\Ups\upsshipStruct\UpsShipperFiledType $shipperFiled = null)
    {
        $this->ShipperFiled = $shipperFiled;
        return $this;
    }
}
