<?php

namespace Ups\upsshipStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExcludeFromFormType upsshipStruct
 * @package Ups
 * @subpackage Structs
 */
class UpsExcludeFromFormType extends AbstractStructBase
{
    /**
     * The FormType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var string[]
     */
    public $FormType;
    /**
     * Constructor method for ExcludeFromFormType
     * @uses UpsExcludeFromFormType::setFormType()
     * @param string[] $formType
     */
    public function __construct(array $formType = array())
    {
        $this
            ->setFormType($formType);
    }
    /**
     * Get FormType value
     * @return string[]|null
     */
    public function getFormType()
    {
        return $this->FormType;
    }
    /**
     * This method is responsible for validating the values passed to the setFormType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFormType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFormTypeForArrayConstraintsFromSetFormType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $excludeFromFormTypeFormTypeItem) {
            // validation for constraint: itemType
            if (!is_string($excludeFromFormTypeFormTypeItem)) {
                $invalidValues[] = is_object($excludeFromFormTypeFormTypeItem) ? get_class($excludeFromFormTypeFormTypeItem) : sprintf('%s(%s)', gettype($excludeFromFormTypeFormTypeItem), var_export($excludeFromFormTypeFormTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FormType property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FormType value
     * @throws \InvalidArgumentException
     * @param string[] $formType
     * @return \Ups\upsshipStruct\UpsExcludeFromFormType
     */
    public function setFormType(array $formType = array())
    {
        // validation for constraint: array
        if ('' !== ($formTypeArrayErrorMessage = self::validateFormTypeForArrayConstraintsFromSetFormType($formType))) {
            throw new \InvalidArgumentException($formTypeArrayErrorMessage, __LINE__);
        }
        $this->FormType = $formType;
        return $this;
    }
    /**
     * Add item to FormType value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \Ups\upsshipStruct\UpsExcludeFromFormType
     */
    public function addToFormType($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The FormType property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FormType[] = $item;
        return $this;
    }
}
