<?php

namespace Ups\upsshipStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NegotiatedChargesType upsshipStruct
 * @package Ups
 * @subpackage Structs
 */
class UpsNegotiatedChargesType extends AbstractStructBase
{
    /**
     * The ItemizedCharges
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Ups\upsshipStruct\UpsShipChargeType[]
     */
    public $ItemizedCharges;
    /**
     * Constructor method for NegotiatedChargesType
     * @uses UpsNegotiatedChargesType::setItemizedCharges()
     * @param \Ups\upsshipStruct\UpsShipChargeType[] $itemizedCharges
     */
    public function __construct(array $itemizedCharges = array())
    {
        $this
            ->setItemizedCharges($itemizedCharges);
    }
    /**
     * Get ItemizedCharges value
     * @return \Ups\upsshipStruct\UpsShipChargeType[]|null
     */
    public function getItemizedCharges()
    {
        return $this->ItemizedCharges;
    }
    /**
     * This method is responsible for validating the values passed to the setItemizedCharges method
     * This method is willingly generated in order to preserve the one-line inline validation within the setItemizedCharges method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateItemizedChargesForArrayConstraintsFromSetItemizedCharges(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $negotiatedChargesTypeItemizedChargesItem) {
            // validation for constraint: itemType
            if (!$negotiatedChargesTypeItemizedChargesItem instanceof \Ups\upsshipStruct\UpsShipChargeType) {
                $invalidValues[] = is_object($negotiatedChargesTypeItemizedChargesItem) ? get_class($negotiatedChargesTypeItemizedChargesItem) : sprintf('%s(%s)', gettype($negotiatedChargesTypeItemizedChargesItem), var_export($negotiatedChargesTypeItemizedChargesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ItemizedCharges property can only contain items of type \Ups\upsshipStruct\UpsShipChargeType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ItemizedCharges value
     * @throws \InvalidArgumentException
     * @param \Ups\upsshipStruct\UpsShipChargeType[] $itemizedCharges
     * @return \Ups\upsshipStruct\UpsNegotiatedChargesType
     */
    public function setItemizedCharges(array $itemizedCharges = array())
    {
        // validation for constraint: array
        if ('' !== ($itemizedChargesArrayErrorMessage = self::validateItemizedChargesForArrayConstraintsFromSetItemizedCharges($itemizedCharges))) {
            throw new \InvalidArgumentException($itemizedChargesArrayErrorMessage, __LINE__);
        }
        $this->ItemizedCharges = $itemizedCharges;
        return $this;
    }
    /**
     * Add item to ItemizedCharges value
     * @throws \InvalidArgumentException
     * @param \Ups\upsshipStruct\UpsShipChargeType $item
     * @return \Ups\upsshipStruct\UpsNegotiatedChargesType
     */
    public function addToItemizedCharges(\Ups\upsshipStruct\UpsShipChargeType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Ups\upsshipStruct\UpsShipChargeType) {
            throw new \InvalidArgumentException(sprintf('The ItemizedCharges property can only contain items of type \Ups\upsshipStruct\UpsShipChargeType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ItemizedCharges[] = $item;
        return $this;
    }
}
