<?php

namespace Ups\upsshipStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProducerType upsshipStruct
 * @package Ups
 * @subpackage Structs
 */
class UpsProducerType extends AbstractStructBase
{
    /**
     * The Option
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Option;
    /**
     * The CompanyName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $CompanyName;
    /**
     * The TaxIdentificationNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $TaxIdentificationNumber;
    /**
     * The Address
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups\upsshipStruct\UpsAddressType
     */
    public $Address;
    /**
     * The AttentionName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $AttentionName;
    /**
     * The Phone
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups\upsshipStruct\UpsPhoneType
     */
    public $Phone;
    /**
     * The EMailAddress
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $EMailAddress;
    /**
     * Constructor method for ProducerType
     * @uses UpsProducerType::setOption()
     * @uses UpsProducerType::setCompanyName()
     * @uses UpsProducerType::setTaxIdentificationNumber()
     * @uses UpsProducerType::setAddress()
     * @uses UpsProducerType::setAttentionName()
     * @uses UpsProducerType::setPhone()
     * @uses UpsProducerType::setEMailAddress()
     * @param string $option
     * @param string $companyName
     * @param string $taxIdentificationNumber
     * @param \Ups\upsshipStruct\UpsAddressType $address
     * @param string $attentionName
     * @param \Ups\upsshipStruct\UpsPhoneType $phone
     * @param string $eMailAddress
     */
    public function __construct($option = null, $companyName = null, $taxIdentificationNumber = null, \Ups\upsshipStruct\UpsAddressType $address = null, $attentionName = null, \Ups\upsshipStruct\UpsPhoneType $phone = null, $eMailAddress = null)
    {
        $this
            ->setOption($option)
            ->setCompanyName($companyName)
            ->setTaxIdentificationNumber($taxIdentificationNumber)
            ->setAddress($address)
            ->setAttentionName($attentionName)
            ->setPhone($phone)
            ->setEMailAddress($eMailAddress);
    }
    /**
     * Get Option value
     * @return string|null
     */
    public function getOption()
    {
        return $this->Option;
    }
    /**
     * Set Option value
     * @param string $option
     * @return \Ups\upsshipStruct\UpsProducerType
     */
    public function setOption($option = null)
    {
        // validation for constraint: string
        if (!is_null($option) && !is_string($option)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($option, true), gettype($option)), __LINE__);
        }
        $this->Option = $option;
        return $this;
    }
    /**
     * Get CompanyName value
     * @return string|null
     */
    public function getCompanyName()
    {
        return $this->CompanyName;
    }
    /**
     * Set CompanyName value
     * @param string $companyName
     * @return \Ups\upsshipStruct\UpsProducerType
     */
    public function setCompanyName($companyName = null)
    {
        // validation for constraint: string
        if (!is_null($companyName) && !is_string($companyName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($companyName, true), gettype($companyName)), __LINE__);
        }
        $this->CompanyName = $companyName;
        return $this;
    }
    /**
     * Get TaxIdentificationNumber value
     * @return string|null
     */
    public function getTaxIdentificationNumber()
    {
        return $this->TaxIdentificationNumber;
    }
    /**
     * Set TaxIdentificationNumber value
     * @param string $taxIdentificationNumber
     * @return \Ups\upsshipStruct\UpsProducerType
     */
    public function setTaxIdentificationNumber($taxIdentificationNumber = null)
    {
        // validation for constraint: string
        if (!is_null($taxIdentificationNumber) && !is_string($taxIdentificationNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($taxIdentificationNumber, true), gettype($taxIdentificationNumber)), __LINE__);
        }
        $this->TaxIdentificationNumber = $taxIdentificationNumber;
        return $this;
    }
    /**
     * Get Address value
     * @return \Ups\upsshipStruct\UpsAddressType|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param \Ups\upsshipStruct\UpsAddressType $address
     * @return \Ups\upsshipStruct\UpsProducerType
     */
    public function setAddress(\Ups\upsshipStruct\UpsAddressType $address = null)
    {
        $this->Address = $address;
        return $this;
    }
    /**
     * Get AttentionName value
     * @return string|null
     */
    public function getAttentionName()
    {
        return $this->AttentionName;
    }
    /**
     * Set AttentionName value
     * @param string $attentionName
     * @return \Ups\upsshipStruct\UpsProducerType
     */
    public function setAttentionName($attentionName = null)
    {
        // validation for constraint: string
        if (!is_null($attentionName) && !is_string($attentionName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($attentionName, true), gettype($attentionName)), __LINE__);
        }
        $this->AttentionName = $attentionName;
        return $this;
    }
    /**
     * Get Phone value
     * @return \Ups\upsshipStruct\UpsPhoneType|null
     */
    public function getPhone()
    {
        return $this->Phone;
    }
    /**
     * Set Phone value
     * @param \Ups\upsshipStruct\UpsPhoneType $phone
     * @return \Ups\upsshipStruct\UpsProducerType
     */
    public function setPhone(\Ups\upsshipStruct\UpsPhoneType $phone = null)
    {
        $this->Phone = $phone;
        return $this;
    }
    /**
     * Get EMailAddress value
     * @return string|null
     */
    public function getEMailAddress()
    {
        return $this->EMailAddress;
    }
    /**
     * Set EMailAddress value
     * @param string $eMailAddress
     * @return \Ups\upsshipStruct\UpsProducerType
     */
    public function setEMailAddress($eMailAddress = null)
    {
        // validation for constraint: string
        if (!is_null($eMailAddress) && !is_string($eMailAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eMailAddress, true), gettype($eMailAddress)), __LINE__);
        }
        $this->EMailAddress = $eMailAddress;
        return $this;
    }
}
