<?php
/**
 * This file aims to show you how to use this generated package.
 * In addition, the goal is to show which methods are available and the first needed parameter(s)
 * You have to use an associative array such as:
 * - the key must be a constant beginning with WSDL_ from AbstractSoapClientBase class (each generated ServiceType class extends this class)
 * - the value must be the corresponding key value (each option matches a {@link http://www.php.net/manual/en/soapclient.soapclient.php} option)
 * $options = array(
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_URL => 'https://test.ibenetos.com/ups/Ship.wsdl',
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_TRACE => true,
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_LOGIN => 'you_secret_login',
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_PASSWORD => 'you_secret_password',
 * );
 * etc...
 */
require_once __DIR__ . '/vendor/autoload.php';
/**
 * Minimal options
 */
$options = array(
    \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_URL => 'https://test.ibenetos.com/ups/Ship.wsdl',
    \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_CLASSMAP => \Ups\UpsClassMap::get(),
);
/**
 * Samples for Process ServiceType
 */
$process = new \Ups\upsshipService\UpsProcess($options);
$process->setSoapHeaderUPSSecurity(new \Ups\upsshipStruct\UpsUPSSecurity());
/**
 * Sample call for ProcessShipment operation/method
 */
if ($process->ProcessShipment(new \Ups\upsshipStruct\UpsShipmentRequest()) !== false) {
    print_r($process->getResult());
} else {
    print_r($process->getLastError());
}
/**
 * Sample call for ProcessShipConfirm operation/method
 */
if ($process->ProcessShipConfirm(new \Ups\upsshipStruct\UpsShipConfirmRequest()) !== false) {
    print_r($process->getResult());
} else {
    print_r($process->getLastError());
}
/**
 * Sample call for ProcessShipAccept operation/method
 */
if ($process->ProcessShipAccept(new \Ups\upsshipStruct\UpsShipAcceptRequest()) !== false) {
    print_r($process->getResult());
} else {
    print_r($process->getLastError());
}
